kurse <- read.table(choose.files(), header =TRUE, sep=";", dec=",")

p <- 0.025
# Kurse sortieren
n <- dim(kurse)[1]
kurse <- kurse[n:1,]
kurse <- kurse[,-6]

# log-Renditen bestimmen
rend <- apply(kurse[,-1],2, function(x) log(x[-1]/x[-length(x)]))
rend <- rbind(0,rend)
date=as.character(kurse[,1]) # Datum rausschreiben
# I= Index der Jahresanfaenge
I <- c( which(date=="02.01.2006"),
        which( date=="01.01.2007"),
       which(  date=="01.01.2008"),
       which(   date=="01.01.2009"),
       which(   date=="01.01.2010"),
       which(   date=="03.01.2011"),
        which(   date=="02.01.2012"),
       which(    date=="01.01.2013"),
       which(   date=="01.01.2014"),
       which(  date=="01.01.2015"),
       which(    date=="01.01.2016"))

#Fuer die Schleife                                                                               ,
I <- c(I, (length(date)+1))
#  J Indizes fr den Fiiting beginn
J <- c(
  which(date=="01.01.1996"),
  which(date=="01.01.1997"),
  which(date=="01.01.1998"),
  which(date=="01.01.1999"),
  which(date=="03.01.2000"),
  which(date=="01.01.2001"),
  which(date=="01.01.2002"),
  which(date=="01.01.2003"),
  which(date=="01.01.2004"),
  which(date=="03.01.2005"),
  which(date=="02.01.2006"),
  which( date=="01.01.2007")
)
# Calculate means
iyear <- 2006:2016
nyear <-length(iyear)-1

mean.rendite <- mean.vol <- 0
for(i in 1:nyear) {
  mean.rendite[i] <-  mean(((kurse[I[i+1]-1,-1]/kurse[I[i],-1])^(1/(I[i+1]-I[i]))  -1)*100)
  mean.vol[i] <-  mean(apply(kurse[(I[i]+1):(I[i+1]-1),-1] /kurse[I[i]:(I[i+1]-2),-1],2,sd) *100)
}


### Modellanpassung
library("tseries")
library("fGarch")
library("rugarch")






# Spezifikation fuer standard Garch, GJR Garch und E Garch

specS = ugarchspec(variance.model=list(model="sGARCH", garchOrder=c(1,1)), mean.model=list(armaOrder=c(1,1), include.mean=TRUE), distribution.model="sstd")
specGJR = ugarchspec(variance.model=list(model="gjrGARCH", garchOrder=c(1,1)), mean.model=list(armaOrder=c(1,1), include.mean=TRUE), distribution.model="sstd")
specE = ugarchspec(variance.model=list(model="eGARCH", garchOrder=c(1,1)), mean.model=list(armaOrder=c(1,1), include.mean=TRUE), distribution.model="sstd")

for(k in 1:(length(iyear))){
  print(paste("Fitte von",date[I[k]],"bis",date[(I[k+1]-1)]))

  HH.S <- matrix(NA, nrow=length(I[k]:(I[k+1]-1)) ,ncol=13)
  HH.GJR <- matrix(NA, nrow=length(I[k]:(I[k+1]-1)) ,ncol=13)
  HH.E <- matrix(NA, nrow=length(I[k]:(I[k+1]-1)) ,ncol=13)

  for(j in 1:dim(rend)[2]){
    print(paste("...Businessline",j, "von",dim(rend)[2] ) )
    # Fitte and die Renditen bis vor Jahr k, also bis Tag I[k]-1
    fit.S = ugarchfit(specS, data = rend[J[k]:(I[k]-1),j],solver="hybrid")
    fit.GJR = ugarchfit(specGJR, data = rend[J[k]:(I[k]-1),j],solver="hybrid" )
    fit.E = ugarchfit(specE, data = rend[J[k]:(I[k]-1),j],solver="hybrid")
    # Fuer die vorhersage verwende die gefitteten Parameter
    spec2.S = specS
    spec2.GJR = specGJR
    spec2.E = specE
    setfixed(spec2.S)<-as.list(coef(fit.S))
    setfixed(spec2.GJR)<-as.list(coef(fit.GJR))
    setfixed(spec2.E)<-as.list(coef(fit.E))
    # Bestimme die epsilon_t, z.B residuals(filt.S) ab I[k] bis I[k+1]-1
    filt.S = ugarchfilter(spec2.S, data = rend[I[k]:(I[k+1]-1),j])
    filt.GJR = ugarchfilter(spec2.GJR, data = rend[I[k]:(I[k+1]-1),j])
    filt.E = ugarchfilter(spec2.E, data = rend[I[k]:(I[k+1]-1),j])
    # Bestimme die Reihe der H's
    HH.S[,j] <- ( 1-  pdist("sstd",residuals(filt.S,standardize=TRUE), mu = 0, sigma = 1, skew=coef(fit.S)["skew"],  shape=coef(fit.S)["shape"])/p) *(pdist("sstd",residuals(filt.S,standardize=TRUE), mu = 0, sigma = 1,   shape=coef(fit.S)["shape"])<p)
    HH.GJR[,j] <- ( 1-  pdist("sstd",residuals(filt.GJR,standardize=TRUE), mu = 0, sigma = 1, skew=coef(fit.GJR)["skew"],   shape=coef(fit.GJR)["shape"])/p) *(pdist("sstd",residuals(filt.GJR,standardize=TRUE), mu = 0, sigma = 1,   shape=coef(fit.GJR)["shape"])<p)
    HH.E[,j] <- ( 1-  pdist("sstd",residuals(filt.E,standardize=TRUE), mu = 0, sigma = 1,  skew = coef(fit.E)["skew"], shape=coef(fit.E)["shape"])/p) *(pdist("sstd",residuals(filt.E,standardize=TRUE), mu = 0, sigma = 1,   shape=coef(fit.E)["shape"])<p)
  }
  #Schreibe die H's in eine Liste
  # Bei 2006 k=1 wird Liste erstellt
  if(k==1) {
    AllH.S <- list(HH.S)
    AllH.GJR <- list(HH.GJR)
    AllH.E <- list(HH.E)
  }
  # Bei 2007... wird die Liste ergaent
  if(k>1){
    AllH.S[[k]] <- HH.S
    AllH.GJR[[k]] <- HH.GJR
    AllH.E[[k]] <- HH.E
    }

}

#save(AllH.S,AllH.GJR,AllH.E, file="...")




