# Irwin-Hall Distribution
IH <- function(x,nn){
    #Helpfunction
    ih <- function(x,n){
      if(x<=0) return(0)
      if(x>=n) return(1)
      if(n>=20) return(pnorm( (x-(n/2))/sqrt(n/12) ))
      else{
      k <- 0:floor(x)
      return(sum((-1)^k *(x-k)^n/(factorial(k)*factorial(n-k) )) )
      }
    }
    erg <- matrix(nrow=length(x), ncol=length(nn))
    for(i in 1:length(nn)){
      n <- nn[i]
      erg[,i] <-  apply(matrix(x),1,function(x)ih(x,n))
      }
      return(erg)
       }

# Distribution teststatistic
ph4 <- function(x, p=0.025){
    erg <- numeric(length(x))
    if(any(sum(x)==0)) return(paste("Achtung bedingt auf x>0"))
    k <- 1:n
    IHH <- t(IH(x,k))
   binom <- dbinom(k,n,p)
   erg <- (1-(1-p)^n)^-1 * apply(rbind(IHH) * binom,2,sum)
   erg[erg>=1] <- 1-10^-16             # solving numerical problems
  return(erg)
}


# Bootstrap is just exmeprimental
a.test.size <- function(H,p=0.025,alpha=0.05, ind0=FALSE, boot=FALSE, B=500){
     H <- as.matrix(H)
     n <- dim(H)[1]
     m <- dim(H)[2]
     
      if(!ind0& boot){    #relevanter Fall
      H. <- apply(H,2,sum)
      U <- numeric(m)
      for(i in 1:m) U[i] <- ph4(H.[i])
      TT <- sum(qnorm(U))
      # bootstrap     # 0en vermeiden
      booten <- function(H){
              erg <- 0
              while(any(erg==0)) erg <-  apply(as.matrix(H[sample(1:n,n,replace=TRUE),]),2,sum)
              return(erg)
              }
      BB <- t(replicate(B,booten(H)))
      BB2 <- apply(as.matrix(apply(BB,1,ph4)),2,function(x) sum(qnorm(x)))
      s2 <- var(BB2)

      pval <- 1-pnorm(TT,0, sqrt(s2))
      entscheid  <- pval<0.05
      }
      
      if(!ind0& !boot){
       H. <- apply(H,2,sum)
      U <- numeric(m)
      for(i in 1:m) U[i] <- ph4(H.[i])
      TT <- sum(qnorm(U))

      Sigma <- cor(H)
      s2 <- sum(Sigma)
      pval <- 1-pnorm(TT,0, sqrt(s2))
      #entscheid  <- pval<0.05
      }
     return(pval)
     }